Subject: Re: sam460ex, sm501 incorrect device id with kernel >=linux-2.6.39

From: Anatolij Gustschin <[email-masked]>
Date: Mon, 28 Nov 2011 21:22:24 +0100

On Mon, 28 Nov 2011 20:56:55 +0100
acrux <[email-masked]> wrote:
...
> it seems to be an endianess issue but i didn't find when it was
> introduced.  Really strange this kind of issue was never noticed
> bumping from 2.6.38.x to 2.6.39.x .

Look at commit bf5f0019046d596d613caf74722ba4994e153899
(video, sm501: add I/O functions for use on powerpc).
This is the issue, I think. Especially changes in include/linux/sm501.h
by this commit. Since CONFIG_PPC32 is defined for canyonlands,
ioread32be() is used to access the registers at PCI space which
is wrong. The patch was tested on tqm5200 with sm501 connected
on localbus, so using ioread32be() worked there. Your sm502 is on
PCI bus I suppose. This issue needs to be fixed.

HTH,
Anatolij